#pragma once

#include <vector>

class FrontEnd
{
public:
	FrontEnd(void);
	~FrontEnd(void);

	void StartSpy();
	void StopSpy();
	void InstallAutorun();
	void UninstallAutorun();
	void CheckAutorun();
	bool IsActiveProtection();
	bool IsInstalled();
	void DeleteAutorun(const std::vector<CAtlString>& inf_files);

private:

	static	bool IsModulePresent(DWORD process_id, LPCTSTR module_short_name, 
									CAtlString* module_actual_name);
			void GetExplorerProcess(DWORD* process_id);
private:

	bool		m_start_spy;
	std::string	m_inject_module_path;
};

extern FrontEnd g_front_end;