#pragma once

#include "IHookPool.h"
#include <vector>
#include <map>


class HookPool: public IHookPool
{
public:
	HookPool(void);
	~HookPool(void);

	virtual void AddHook(IHook* seted_hook);

	void SetAllHooks();
	void ClearSetedHooks();
	void SetModuleHooks(const char* module_name);
	void SetNotSetedHooks();


private:
	std::vector<IHook*> m_module_hook;
};
