#define _WIN32_WINNT 0x0501
#include <Windows.h>
#include <tchar.h>
#include <stdio.h>
#include "Macros.h"
#include "HookProcs.h"
#include "HookPool.h"
#include "THook.h"
#include "HookDelayLoadedDll.h"
//#include "LogClient.h"


struct Hooks
{
	Hooks(IHookPool* hook_pool): 
	m_GetFileAttributesW(hook_pool,_T("Kernel32.dll"),"GetFileAttributesW",Hook_GetFileAttributesW,GetFileAttributesW){}
// 		m_CreateFileW(hook_pool,_T("Kernel32.dll"),"CreateFileW",Hook_CreateFileW,CreateFileW),
// 		m_FindFirstFileA(hook_pool,_T("Kernel32.dll"),"FindFirstFileA",Hook_FindFirstFileA,FindFirstFileA),
// 		m_FindFirstFileExA(hook_pool,_T("Kernel32.dll"),"FindFirstFileExA",Hook_FindFirstFileExA,FindFirstFileExA),
// 		m_FindNextFileW(hook_pool,_T("Kernel32.dll"),"FindNextFileW",Hook_FindNextFileW,FindNextFileW), 
// 		m_FindFirstFileW(hook_pool,_T("Kernel32.dll"),"FindFirstFileW",Hook_FindFirstFileW,FindFirstFileW),
// 		m_FindFirstFileExW(hook_pool,_T("Kernel32.dll"),"FindFirstFileExW",Hook_FindFirstFileExW,FindFirstFileExW){} 
// 		m_CreateProcessW(hook_pool,_T("Kernel32.dll"),"CreateProcessW",Hook_CreateProcessW,CreateProcessW){} 
// 		m_CreateProcessA(hook_pool,_T("Kernel32.dll"),"CreateProcessA",Hook_CreateProcessA,CreateProcessA){}


	THook<DWORD WINAPI(LPCWSTR)> 
		m_GetFileAttributesW; 

// 	THook<HANDLE WINAPI(LPCWSTR,DWORD,DWORD,LPSECURITY_ATTRIBUTES,DWORD,DWORD,HANDLE)> 
// 		m_CreateFileW; 
// 
// 	THook<HANDLE WINAPI(LPCSTR,LPWIN32_FIND_DATAA)> 
// 		m_FindFirstFileA; 
// 	THook<HANDLE WINAPI(LPCSTR,FINDEX_INFO_LEVELS,LPVOID,FINDEX_SEARCH_OPS,LPVOID,DWORD)> 
// 		m_FindFirstFileExA; 
// 
// 	THook<BOOL WINAPI(HANDLE,LPWIN32_FIND_DATAW)> 
// 		m_FindNextFileW; 
// 	THook<HANDLE WINAPI(LPCWSTR,FINDEX_INFO_LEVELS,LPVOID,FINDEX_SEARCH_OPS,LPVOID,DWORD)>
// 		m_FindFirstFileExW;
// 	THook<HANDLE WINAPI(LPCWSTR,LPWIN32_FIND_DATAW)>
// 		m_FindFirstFileW; 
		   
// 	THook<BOOL WINAPI(LPCWSTR,LPWSTR,LPSECURITY_ATTRIBUTES,LPSECURITY_ATTRIBUTES,BOOL,
// 		DWORD,LPVOID,LPCWSTR,LPSTARTUPINFOW,LPPROCESS_INFORMATION)> 
// 		m_CreateProcessW; 
// 	THook<BOOL WINAPI(LPCSTR,LPSTR,LPSECURITY_ATTRIBUTES,LPSECURITY_ATTRIBUTES,BOOL,
// 		DWORD,LPVOID,LPCSTR,LPSTARTUPINFOA,LPPROCESS_INFORMATION)> 
// 		m_CreateProcessA; 

	static DWORD WINAPI Hook_GetFileAttributesW(
		IN LPCWSTR lpFileName
		);

// 	static HANDLE WINAPI Hook_CreateFileW(
// 		IN LPCWSTR lpFileName,
// 		IN DWORD dwDesiredAccess,
// 		IN DWORD dwShareMode,
// 		IN LPSECURITY_ATTRIBUTES lpSecurityAttributes,
// 		IN DWORD dwCreationDisposition,
// 		IN DWORD dwFlagsAndAttributes,
// 		IN HANDLE hTemplateFile
// 		);
// 
// 	static HANDLE WINAPI Hook_FindFirstFileA(
// 		IN LPCSTR lpFileName,
// 		OUT LPWIN32_FIND_DATAA lpFindFileData
// 		);
// 
// 	static HANDLE WINAPI Hook_FindFirstFileExA(
// 		IN LPCSTR lpFileName,
// 		IN FINDEX_INFO_LEVELS fInfoLevelId,
// 		OUT LPVOID lpFindFileData,
// 		IN FINDEX_SEARCH_OPS fSearchOp,
// 		IN LPVOID lpSearchFilter,
// 		IN DWORD dwAdditionalFlags
// 		);
// 
// 	static HANDLE WINAPI Hook_FindFirstFileExW(
// 		IN LPCWSTR lpFileName,
// 		IN FINDEX_INFO_LEVELS fInfoLevelId,
// 		OUT LPVOID lpFindFileData,
// 		IN FINDEX_SEARCH_OPS fSearchOp,
// 		IN LPVOID lpSearchFilter,
// 		IN DWORD dwAdditionalFlags
// 		);
// 
// 	static BOOL WINAPI Hook_FindNextFileW(
// 		IN HANDLE hFindFile,
// 		OUT LPWIN32_FIND_DATAW lpFindFileData
// 		);
// 
// 	static HANDLE WINAPI Hook_FindFirstFileW(
// 		IN LPCWSTR lpFileName,
// 		OUT LPWIN32_FIND_DATAW lpFindFileData
// 		);

// 	static BOOL WINAPI Hook_CreateProcessW(
// 		IN LPCWSTR lpApplicationName,
// 		IN LPWSTR lpCommandLine,
// 		IN LPSECURITY_ATTRIBUTES lpProcessAttributes,
// 		IN LPSECURITY_ATTRIBUTES lpThreadAttributes,
// 		IN BOOL bInheritHandles,
// 		IN DWORD dwCreationFlags,
// 		IN LPVOID lpEnvironment,
// 		IN LPCWSTR lpCurrentDirectory,
// 		IN LPSTARTUPINFOW lpStartupInfo,
// 		OUT LPPROCESS_INFORMATION lpProcessInformation
// 		);
// 
// 	static BOOL WINAPI Hook_CreateProcessA(
// 		IN LPCSTR lpApplicationName,
// 		IN LPSTR lpCommandLine,
// 		IN LPSECURITY_ATTRIBUTES lpProcessAttributes,
// 		IN LPSECURITY_ATTRIBUTES lpThreadAttributes,
// 		IN BOOL bInheritHandles,
// 		IN DWORD dwCreationFlags,
// 		IN LPVOID lpEnvironment,
// 		IN LPCSTR lpCurrentDirectory,
// 		IN LPSTARTUPINFOA lpStartupInfo,
// 		OUT LPPROCESS_INFORMATION lpProcessInformation
// 		);

};

Hooks*		g_hook;
//LogClient	g_log;


class Initialiser
{
public:
	Initialiser():
// 	m_hook_pool(),
// 	m_internals(&m_hook_pool),
	m_hooks(NULL)
	{
// 		m_hook_pool.SetAllHooks();
		g_hook=&m_hooks;
	}

	~Initialiser()
	{
// 		m_hook_pool.ClearSetedHooks();
		g_hook=NULL;
	}

private:
// 	HookDelayLoadedDll	m_internals;
// 	HookPool		m_hook_pool;
	Hooks			m_hooks;
};

Initialiser init;

//-------------------------------------------------------

// void ChangeName(HANDLE hfind, LPCWSTR find_path, LPWIN32_FIND_DATAW data)
// {
// 	static HANDLE	s_hfind=INVALID_HANDLE_VALUE;
// 	static bool		s_removable_drive=false;
// 
// 	if(find_path!=NULL)
// 	{
// 		s_removable_drive=false;
// 		s_hfind=hfind;
// 	}
// 
// 	if(s_hfind!=hfind)
// 		return;
// 	if(hfind==INVALID_HANDLE_VALUE)
// 		return;
// 
// 	if(find_path!=NULL)
// 	{
// 		wchar_t* target_file=L":\\";
// 		if( 0 == wcsncmp(&find_path[1],target_file,2) )
// 		{
// 			wchar_t drive[4];
// 			UINT	drive_type;
// 			wcsncpy(drive,find_path,3);
// 			drive[3]=0;
// 
// 			drive_type=GetDriveTypeW(drive);
// //  			if(drive_type==DRIVE_REMOVABLE)// DRIVE_REMOTE DRIVE_REMOVABLE
// 				s_removable_drive=true;
// 		}
// 	}
// 
// 	if(!s_removable_drive)
// 		return;
// 
// 	wchar_t checked_file[COUNTOF(data->cFileName)];
// 	wcscpy(checked_file,data->cFileName);
// 	_wcslwr(checked_file);
// 
// 	{
// 		wchar_t* target_file=L"autorun.inf";
// 		wchar_t* match;
// 
// 		match=wcsstr(checked_file,target_file);
// 
// 		if( NULL!=match  )
// 		{
// 			size_t offset = match - checked_file;
// 			offset+=wcslen(target_file);
// 			data->cFileName[offset-1]=_T('_');
// 		}
// 	}
// }

//-------------------------------------------------------
DWORD WINAPI Hooks::Hook_GetFileAttributesW(
	IN LPCWSTR lpFileName
	)
{
	if(0==_wcsicmp(&lpFileName[1],L":\\autorun.inf"))
	{
		SetLastError(ERROR_FILE_NOT_FOUND);
		return -1;
	}

	DWORD	api_result;
	api_result=g_hook->m_GetFileAttributesW.m_original(lpFileName);
	return api_result;
}

// HANDLE WINAPI Hooks::Hook_CreateFileW(
// 									  IN LPCWSTR lpFileName,
// 									  IN DWORD dwDesiredAccess,
// 									  IN DWORD dwShareMode,
// 									  IN LPSECURITY_ATTRIBUTES lpSecurityAttributes,
// 									  IN DWORD dwCreationDisposition,
// 									  IN DWORD dwFlagsAndAttributes,
// 									  IN HANDLE hTemplateFile
// 									  )
// {
// 	{
// 		size_t	actual;
// 		wchar_t	buffer[1024*4];
// 		actual=_snwprintf(buffer,COUNTOF(buffer),L"CreateFileW:%s",lpFileName);
// 		g_log.SendMsg(buffer,actual+1);
// 	}
// 	HANDLE	api_result;
// 	api_result=g_hook->m_CreateFileW.m_original(lpFileName,dwDesiredAccess,dwShareMode,lpSecurityAttributes,dwCreationDisposition,dwFlagsAndAttributes,hTemplateFile);
// 	return api_result;
// }
// 
// HANDLE WINAPI Hooks::Hook_FindFirstFileA(
// 	IN LPCSTR lpFileName,
// 	OUT LPWIN32_FIND_DATAA lpFindFileData
// 	)
// {
// 	{
// 		int	actual;
// 		char	buffer[1024*4];
// 		wchar_t w_buffer[1024*4];
// 		actual=_snprintf(buffer,COUNTOF(buffer),"FindFirstFileA:%s",lpFileName);
// 		actual=MultiByteToWideChar(CP_THREAD_ACP,0,buffer,actual+1,w_buffer,COUNTOF(w_buffer));
// 		g_log.SendMsg(w_buffer,actual);
// 	}
// 
// 	HANDLE	api_result;
// 	api_result=g_hook->m_FindFirstFileA.m_original(lpFileName,lpFindFileData);
// 	return api_result;
// }
// 
// HANDLE WINAPI Hooks::Hook_FindFirstFileExA(
// 	IN LPCSTR lpFileName,
// 	IN FINDEX_INFO_LEVELS fInfoLevelId,
// 	OUT LPVOID lpFindFileData,
// 	IN FINDEX_SEARCH_OPS fSearchOp,
// 	IN LPVOID lpSearchFilter,
// 	IN DWORD dwAdditionalFlags
// 	)
// {
// 	{
// 		int		actual;
// 		char	buffer[1024*4];
// 		wchar_t w_buffer[1024*4];
// 		actual=_snprintf(buffer,COUNTOF(buffer),"FindFirstFileExA:%s",lpFileName);
// 		actual=MultiByteToWideChar(CP_THREAD_ACP,0,buffer,actual+1,w_buffer,COUNTOF(w_buffer));
// 		g_log.SendMsg(w_buffer,actual);
// 	}
// 
// 	HANDLE	api_result;
// 	api_result=g_hook->m_FindFirstFileExA.m_original(lpFileName,fInfoLevelId,lpFindFileData,fSearchOp,lpSearchFilter,dwAdditionalFlags);
// 	return api_result;
// }
// 
// HANDLE WINAPI Hooks::Hook_FindFirstFileExW(
// 	IN LPCWSTR lpFileName,
// 	IN FINDEX_INFO_LEVELS fInfoLevelId,
// 	OUT LPVOID lpFindFileData,
// 	IN FINDEX_SEARCH_OPS fSearchOp,
// 	IN LPVOID lpSearchFilter,
// 	IN DWORD dwAdditionalFlags
// 	)
// {
// 	HANDLE	api_result;
// 
// // 	{
// // 		size_t	actual;
// // 		wchar_t	buffer[1024*4];
// // 		actual=_snwprintf(buffer,COUNTOF(buffer),L"FindFirstFileExW:%s",lpFileName);
// // 		g_log.SendMsg(buffer,actual+1);
// // 	}
// 
// 	api_result=g_hook->m_FindFirstFileExW.m_original(lpFileName,fInfoLevelId,lpFindFileData,fSearchOp,lpSearchFilter,dwAdditionalFlags);
// 	if(fInfoLevelId==FindExInfoStandard)
// 		ChangeName(api_result,lpFileName,(LPWIN32_FIND_DATAW)lpFindFileData);
// 	return api_result;
// }
// 
// BOOL WINAPI Hooks::Hook_FindNextFileW(
// 								 IN HANDLE hFindFile,
// 								 OUT LPWIN32_FIND_DATAW lpFindFileData
// 								 )
// {
// 	BOOL	api_result;
// 	api_result=g_hook->m_FindNextFileW.m_original(hFindFile,lpFindFileData);
// 	ChangeName(hFindFile,NULL,lpFindFileData);
// 	return api_result;
// }
// 
// HANDLE WINAPI Hooks::Hook_FindFirstFileW(
// 	IN LPCWSTR lpFileName,
// 	OUT LPWIN32_FIND_DATAW lpFindFileData
// 				 )
// {
// 	HANDLE	api_result;
// 
// // 	{
// // 		size_t	actual;
// // 		wchar_t	buffer[1024*4];
// // 		actual=_snwprintf(buffer,COUNTOF(buffer),L"FindFirstFileW:%s",lpFileName);
// // 		g_log.SendMsg(buffer,actual+1);
// // 	}
// 
// 	api_result=g_hook->m_FindFirstFileW.m_original(lpFileName,lpFindFileData);
// 
// 	ChangeName(api_result,lpFileName,lpFindFileData);
// 	return api_result;
// }

// BOOL WINAPI Hooks::Hook_CreateProcessW(
// 									   IN LPCWSTR lpApplicationName,
// 									   IN LPWSTR lpCommandLine,
// 									   IN LPSECURITY_ATTRIBUTES lpProcessAttributes,
// 									   IN LPSECURITY_ATTRIBUTES lpThreadAttributes,
// 									   IN BOOL bInheritHandles,
// 									   IN DWORD dwCreationFlags,
// 									   IN LPVOID lpEnvironment,
// 									   IN LPCWSTR lpCurrentDirectory,
// 									   IN LPSTARTUPINFOW lpStartupInfo,
// 									   OUT LPPROCESS_INFORMATION lpProcessInformation
// 									   )
// {
// 
// 	{
// 		size_t	actual;
// 		wchar_t	buffer[1024*4];
// 		actual=_snwprintf(buffer,COUNTOF(buffer),L"app:%s cmd:%s", lpApplicationName, lpCommandLine);
// 		g_log.SendMsg(buffer,actual+1);
// 	}
// 
// 
// 	BOOL	api_result;
// 	api_result=g_hook->m_CreateProcessW.m_original(lpApplicationName,
// 		lpCommandLine,
// 		lpProcessAttributes,
// 		lpThreadAttributes,
// 		bInheritHandles,
// 		dwCreationFlags,
// 		lpEnvironment,
// 		lpCurrentDirectory,
// 		lpStartupInfo,
// 		lpProcessInformation);
// 	return api_result;
// }
// 
// BOOL WINAPI Hooks::Hook_CreateProcessA(
// 									   IN LPCSTR lpApplicationName,
// 									   IN LPSTR lpCommandLine,
// 									   IN LPSECURITY_ATTRIBUTES lpProcessAttributes,
// 									   IN LPSECURITY_ATTRIBUTES lpThreadAttributes,
// 									   IN BOOL bInheritHandles,
// 									   IN DWORD dwCreationFlags,
// 									   IN LPVOID lpEnvironment,
// 									   IN LPCSTR lpCurrentDirectory,
// 									   IN LPSTARTUPINFOA lpStartupInfo,
// 									   OUT LPPROCESS_INFORMATION lpProcessInformation
// 									   )
// {
// 
// 	{
// 		size_t	actual;
// 		wchar_t	buffer[1024*4];
// 		actual=_snwprintf(buffer,COUNTOF(buffer),L"app:%S cmd:%S", lpApplicationName, lpCommandLine);
// 		g_log.SendMsg(buffer,actual+1);
// 	}
// 
// 
// 	BOOL	api_result;
// 	api_result=g_hook->m_CreateProcessA.m_original(lpApplicationName,
// 		lpCommandLine,
// 		lpProcessAttributes,
// 		lpThreadAttributes,
// 		bInheritHandles,
// 		dwCreationFlags,
// 		lpEnvironment,
// 		lpCurrentDirectory,
// 		lpStartupInfo,
// 		lpProcessInformation);
// 	return api_result;
// }


//-------------------------------------------------------

BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
	switch (ul_reason_for_call)
	{
	case DLL_PROCESS_ATTACH:
// 		OutputDebugString(_T("Hook_DLL DLL_PROCESS_ATTACH\n"));
		break;
	case DLL_THREAD_ATTACH:
		break;
	case DLL_THREAD_DETACH:
		break;
	case DLL_PROCESS_DETACH:
// 		OutputDebugString(_T("Hook_DLL DLL_PROCESS_DETACH\n"));
		break;
	}
    return TRUE;
}
