#pragma once

#define COUNTOF(array) (sizeof(array)/sizeof(array[0]))
#define SAFE_DELETE(pointer) {if(pointer!=NULL){delete pointer; pointer=NULL;}}

#define msgstr( x )		#x
#define msgstr2( x )	msgstr( x )
#define remind( desc )	message( __FILE__ "(" msgstr2( __LINE__ ) ") : " #desc )
#define todo( desc )	message( __FILE__ "(" msgstr2( __LINE__ ) ") : TODO " #desc )
#define hack( desc )	message( __FILE__ "(" msgstr2( __LINE__ ) ") : hack " #desc )

#ifdef _DEBUG
#define Assert DebugBreak
#else
#define Assert __noop
#endif


#define return_x(x)						{ Assert(); return x; }
#define return_x_if_not_equal(x1,x2,x)	{ if( x1 != x2 ) { Assert(); return x;} }
#define return_x_if_equal(x1,x2,x)		{ if( x1 == x2 ) { Assert(); return x;} }
#define return_if_not_equal(x1,x2)		{ if( x1 != x2 ) { Assert(); return; } }
#define return_if_equal(x1,x2)			{ if( x1 == x2 ) { Assert(); return; } }
#define assert_if_not_equal(x1,x2)		{ if( x1 != x2 ) { Assert(); } }
#define assert_if_equal(x1,x2)			{ if( x1 == x2 ) { Assert(); } }
